public class DoubleLinkedList {

    class ListNode {

        ListNode prev;
        ListNode next;
        Object item;

        ListNode(Object item) {
            this.item = item;
            prev = next = null;
        }
    }

    private ListNode start;
    private ListNode end;

    public DoubleLinkedList() {
        start = null;
    }

    public DoubleLinkedList push(Object obj) {
        ListNode node = new ListNode(obj);
        if (start == null) {
            start = end = node;
        } else {
            node.next = start;
            start.prev = node;
            start = node;
        }
        return this;
    }

    public void print() {
        ListNode cur = start;
        while (cur != null) {
            System.out.print(cur.item + (cur.next == null ? "\n" : " "));
            cur = cur.next;
        }
    }

    public void printReverse() {
        ListNode cur = end;
        while (cur != null) {
            System.out.print(cur.item + (cur.prev == null ? "\n" : " "));
            cur = cur.prev;
        }
    }

}
